package cn.ibizlab.businesscentral.core.extensions.service;

import cn.ibizlab.businesscentral.core.sales.service.impl.OpportunityServiceImpl;
import lombok.extern.slf4j.Slf4j;
import cn.ibizlab.businesscentral.core.sales.domain.Opportunity;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Primary;
import java.util.*;

/**
 * 实体[商机] 自定义服务对象
 */
@Slf4j
@Primary
@Service("OpportunityServiceEx")
public class OpportunityServiceEx extends OpportunityServiceImpl {

    @Override
    protected Class currentModelClass() {
        return com.baomidou.mybatisplus.core.toolkit.ReflectionKit.getSuperClassGenericType(this.getClass().getSuperclass(), 1);
    }

    /**
     * 自定义行为[Win]用户扩展
     * @param et
     * @return
     */
    @Override
    @Transactional
    public Opportunity win(Opportunity et) {
        return super.win(et);
    }
    /**
     * 自定义行为[Lose]用户扩展
     * @param et
     * @return
     */
    @Override
    @Transactional
    public Opportunity lose(Opportunity et) {
        return super.lose(et);
    }
}

